package drakfirsttime::gui;

use strict;
use lib qw(/usr/lib/libDrakX);
use standalone;

use common;
use any;
BEGIN { unshift @::textdomains, 'drakfw' }
#use interactive;
use ugtk2 qw(:all);

use LWP::UserAgent;
use Net::HTTP;
use HTTP::Message;
use HTTP::Request;
use Expect;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $this = bless({
		      version => "0.91",
		      drakfw => N("First Time Wizard") ,
		      mdkclub => N("MandrakeClub Registration"),
		      drakmail => N("Mandrake Generic Mail Configurator"),
		      kdeconfdir => "$ENV{HOME}/.kde/share/config",
		      mozillaconfdir => "$ENV{HOME}/.mozilla/default",
		      evoconfdir => "$ENV{HOME}/evolution"
		     }, $class);
    my $rc = "/usr/share/themes/Galaxy/gtk-2.0/gtkrc";
    Gtk2::Rc->parse($rc);
    add_icon_path("/usr/share/drakfirsttime/pixmaps/");
    $this->initialize(@_);
    return;
}
sub initialize {
    my $this = shift;
    my $prog_name = shift;
    $this->{mw} = ugtk2->new($this->{$prog_name} . " " . $this->{version}, center => 1);
    gtkset_size_request($this->{mw}{window}, 580, 470);
    $this->{mw}{rwindow}->set_position('center');
    $this->{nb} = Gtk2::Notebook->new;
    $this->{Button_SkipWiz} = Gtk2::Button->new(N(" Skip Wizard ")); $this->{Button_Prev} = Gtk2::Button->new_from_stock('gtk-go-back'); $this->{Button_Next} = Gtk2::Button->new_from_stock('gtk-go-forward');
    $this->{is_network} = network_enabled();
    $this->{is_download} = mdk_downloaded();
    my $stage = {
		 drakfw => {
			    0 => sub { $this->start() },
			    1 => sub { $this->set_themes() },
			    2 => sub { $this->set_mail(); !$this->{is_network} && !$this->{is_download} and $this->get2final() },
			    3 => sub { if(!$this->{is_network} && !$this->{is_download}) { $this->startwm() } else { $this->{nb}->next_page() } },
			    4 => sub { $this->{is_download} and $this->survey(); if ($this->{is_download} && !$this->{is_network}) { $this->{nb}->next_page(); $this->get2final() } elsif (!$this->{is_download} && $this->{is_network}) { $this->mdkclub_checkuser() } else { $this->{nb}->next_page() }},
			    5 => sub { if (!$this->{is_network} || !$this->{is_download}) { $this->startwm() } else { $this->{nb}->next_page() } },
			    6 => sub { $this->mdkclub_checkuser() },
			    7 => sub { $this->startwm() }
			   },
		 mdkclub => {
			     0 => sub {$this->start()},
			     2 => sub { $this->mdkclub_checkuser() },
			     3 => sub { Gtk2->main_quit }
			    },
		 drakmail => {
			      0 => sub {$this->start()},
			      1 => sub { $this->ConfirmMailSettings() }, 
			      2 => sub { $this->set_mail(); Gtk2->main_quit }
			     }
		};
    $this->{Button_SkipWiz}->signal_connect( clicked => sub { $prog_name eq 'drakfw' and $this->startwm() or Gtk2->main_quit});
    $this->{Button_Prev}->signal_connect( clicked => sub { $this->on_prev_clicked($stage->{$prog_name}) });
    $this->{Button_Next}->signal_connect( clicked => sub { $this->on_next_clicked($stage->{$prog_name}) });
    my $hbox_final = Gtk2::HBox->new(0, 5);$hbox_final->pack_start($this->{Button_SkipWiz}, 0, 0, 1); $hbox_final->pack_end($this->{Button_Next}, 0, 0, 1); $hbox_final->pack_end($this->{Button_Prev}, 0, 0, 1);
    gtkadd($this->{mw}{window},
	   gtkpack_(Gtk2::VBox->new(0, 2),
		    1, gtkadd($this->build_ui($prog_name)),
		    0, Gtk2::HSeparator->new,
		    0, gtkpack($hbox_final),
		   ),
	  );
    $this->{Button_Prev}->set_sensitive(0);
    $this->{Button_SkipWiz}->grab_focus;
    $this->{mw}{rwindow}->show_all;
    Gtk2->main;
    ugtk2->exit(0);
}
sub start { my $this = shift; $this->{Button_Prev}->set_sensitive(1), $this->{nb}->next_page() }
sub build_ui {
    my $this = shift;
    my $name = shift;
    my $prog = {
		drakfw => sub { $this->drakfirsttime_wizsteps() },
		mdkclub => sub { $this->mdkclub_wizsteps() },
		drakmail => sub { $this->drakmail_wizsteps() }
	       };
    eval { $prog->{$name}->() };
}
sub set_clean {
    my $this = shift;
    $this->{nb}->set_show_tabs(0); $this->{nb}->set_show_border(0);
    my $l = Gtk2::Label->new($_[1]);
#    $l->set_line_wrap('TRUE');
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea($_[0], 'welcome'),
			    1, $l,
			   ) 
		  );
}
sub drakfirsttime_wizsteps {
    my $this = shift;
    $this->set_clean(N("Welcome to First Time Wizard"), N("This is the Mandrake First Time Wizard. This Assistant will help you configure\n the basic setup of your desktop in very few steps.\n If you have an internet connection you'll be able to register for \nMandrake Online Services.\n\nIf you don't want to use this wizard you can press \"Skip Wizard\" button right\nnow and you'll be logged into the default environment\n") . '.');
    my $pxm = Gtk2::Image->new;
    $this->{nbthemes} = Gtk2::Notebook->new;
    $this->{nbthemes}->set_show_tabs(0); 
    $this->{nbthemes}->set_show_border(0);
    gtkappend_page($this->{nbthemes}, Gtk2::Label->new(N("Please Select a Desktop Entry")));
    my %k = ( theme_kde_default => N("Default KDE"), 
	      theme_kde_redmond => N("KDE Redmond"), 
	      theme_kde_keramik => N("KDE Keramik"), 
	      theme_kde_light => N("KDE Light2") 
	    );
    my @k_order = qw(theme_kde_default theme_kde_redmond theme_kde_keramik theme_kde_light);
    my @k_radio = gtkradio($k{theme_kde_default}, map { $k{$_} } @k_order);
    mapn {
	my $kptmp = gtkcreate_pixbuf($_[0]); 
	my $need_ktext = $_[1]->get_label;
	$_[1]->signal_connect(clicked => sub { 
				  $pxm->set_from_pixbuf($kptmp); 
				  $this->{kradio} = $need_ktext 
			      });
    } \@k_order, \@k_radio;
    
    gtkappend_page($this->{nbthemes}, gtkpack(Gtk2::VBox->new(0,0), @k_radio));
    
    my %g = ( theme_gnome_Mandrake_Default => N("Default Mandrake"), 
	      theme_gnome_Ocean_Dream => N("Ocean Dream"),
	      theme_gnome_Gnome_Default => N("Default Gnome"), 
	      theme_gnome_Smokey_Blue => N("Smokey Blue")
	    );
    my @g_order = qw(theme_gnome_Mandrake_Default theme_gnome_Ocean_Dream theme_gnome_Gnome_Default theme_gnome_Smokey_Blue);
    my @g_radio = gtkradio($g{theme_gnome_Mandrake_Default}, map { $g{$_} } @g_order); $this->{gradio} = \@g_radio;
    mapn {
	my $gptmp = gtkcreate_pixbuf($_[0]); 
	my $need_gtext = $_[1]->get_label;
	$_[1]->signal_connect(clicked => sub { 
				  $pxm->set_from_pixbuf($gptmp); 
				  $this->{gradio} = $need_gtext
			      });
    } \@g_order, \@g_radio;
    
    gtkappend_page($this->{nbthemes}, gtkpack(Gtk2::VBox->new(0,0),@g_radio));
    gtkappend_page($this->{nbthemes}, Gtk2::Label->new(N("No themes available")));
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Desktop Appearance"), 'appearence'),
			    0, Gtk2::Label->new(N("Now you can choose your Desktop and the theme you want to be set\n")),
			    0, gtkpack_(Gtk2::HBox->new(0, 0),
					0, gtkpack_(Gtk2::VBox->new(0, 5),
						    0, $this->{wmdesktop} = get_desktop_combo(),
						    0, gtkadd(gtkset_shadow_type(Gtk2::Frame->new(N("Themes")), 'etched_in'),
							      gtkpack(my $vbox_th = Gtk2::VBox->new(0, 0), $this->{nbthemes}
								     ),
							     ),
						   ),
					0, $pxm,
				       ),
			   ),
		  );
    $this->{wmdesktop}->entry->signal_connect(changed => sub { set_background_themes($this->{wmdesktop}->entry->get_text, $this->{nbthemes}, $pxm) });
    $this->mailconf();
    mdk_downloaded() and $this->question();
    network_enabled() and $this->subscribe_mdkclub();
    $this->set_clean(N("Ready to go ?"), N("Congratulations on using Mandrake Linux,\nthe ideal Operating System for beginners and experts. We hope that \nit will be an enjoyable experience.\n\nMandrakeOnline: Discover MandrakeSoft's new online services to easily \nkeep your system up to date with security updates and enhanced software.\n"));
    $this->{nb};
}
sub drakmail_wizsteps {
    my $this = shift;
    $this->set_clean(N("Mandrake Mail Setup"), N("\nThis assistant will help you Setup your mail client\nKmail, Evolution and Mozilla are supported for both IMAP, POP \nand their secure alternatives (SPOP and SIMAP) server types\n"));
    $this->mailconf();
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Congratulations"), 'welcome'),
			    1, $this->{lb} = Gtk2::Label->new(""),
			   ) 
		  ); 
    $this->{nb};
}
sub ConfirmMailSettings {
    my $this = shift;
    $this->{lb}->set_label(N("Please verify that the information below are correct.\n\nMail Client:\t\t\t\t\t%s\nUser Name:\t\t\t\t\t%s\nEmail Address:\t\t\t\t\t%s\nIncoming Server Name:\t\t\t%s\nIncoming Server Type:\t\t\t%s\nOutgoing Server Name(SMTP):\t\t%s\nNews Server:\t\t\t\t\t%s\n\nClick Finish to save these settings and exit the Mail wizard", $this->{mailclient}->entry->get_text(), $this->{maillogin}->get_text(), $this->{mailadd}->get_text(), $this->{incservname}->get_text(), $this->{server}->entry->get_text(), $this->{outservname}->get_text(), $this->{newsserver}->get_text()));
    $this->{Button_Next}->set_label(N("Finish"));
    $this->{nb}->next_page();
}
sub mdkclub_wizsteps {
    my $this = shift;
    $this->set_clean(N("Mandrake Club Account"), N("\nThis assistant will help you to subscribe to Mandrake Club Services,\n"));
    network_enabled() and $this->subscribe_mdkclub();
    $this->set_clean(N("Thank You"), N("You will have more information about the club community at\nhttp://www.mandrakeclub.com.\n"));
    $this->{nb};
}
sub network_enabled {
    my $is_network;
    $is_network = gethostbyname("mandrakeclub.com") ? 1 : 0;
    $is_network;
}
sub mdk_downloaded {
    my %dwn = getVarsFromSh('/etc/sysconfig/system');
    my $isdown = $dwn{META_CLASS} eq 'download' ? 1 : 0;
    $isdown;
}
sub get_mailer {
    my $type = shift;
    my $w;
    $w = Gtk2::Combo->new;
    $type ? $w->set_popdown_strings('', if_(-f '/usr/bin/kmail', 'Kmail'), if_(-f '/usr/bin/evolution', 'Evolution'), if_( -f '/usr/lib/menu/mozilla-maill', 'Mozilla')) : $w->set_popdown_strings('POP', 'IMAP', 'SPOP', 'SIMAP');
    $w->entry->set_editable(0);
    $w
}
sub entry_hidepass {
    my $w;
    $w = entry_sized();
    $w->set_visibility(0);
    $w
}
sub entry_sized {
    my $e;
    $e = Gtk2::Entry->new;
    $e->set_size_request(20, 25);
    $e
}
sub display_entry {
    my $this = shift;
    my @t;
    map {
	$this->{$_} = Gtk2::Entry->new_with_max_length(7);
	$this->{$_}->set_size_request(50,25);
	push(@t, $this->{$_});
	push(@t, Gtk2::Label->new("-"));
    } qw(ent1 ent2 ent3 ent4 ent5);
    pop(@t);push(@t, Gtk2::Label->new(""));
    @t
}
sub get_desktop_combo {
    my $wm_combo = Gtk2::Combo->new;
    my @wm = get_wm_array(); unshift(@wm, N("Choose Desktop"));
    $wm_combo->set_popdown_strings(@wm); $wm_combo->entry->set_editable(0);
    $wm_combo;
}
sub set_background_themes {
    my ($wi, $nb, $pxm) = @_;
    my $bg_path = '/usr/share/drakfirsttime/pixmaps/';
    my $bg = { KDE => [ 'kde_desktop.png', 1, 'theme_kde_default' ],
	       GNOME => [ 'gnome_desktop.png', 2, 'theme_gnome_Mandrake_Default' ],
	       IceWM => [ 'icewm_desktop.png', 3 ],
	       Enlightenment => [ 'e_desktop.png', 3 ],
	       WindowMaker => [ 'wmaker_desktop.png', 3 ],
	       Fvwm1 => [ 'fvwm1_desktop.png', 3 ],
	       Fvwm2 => [ 'fvwm2_desktop.png', 3 ],
	       failsafe => [ 'failsafe', 3 ]
	     };
    if (member($wi, keys %$bg)) { 
	system("qiv -z $bg_path/$bg->{$wi}[0]"); $nb->set_current_page($bg->{$wi}[1]) 
    }
    exists $bg->{$wi}[2] and $pxm->set_from_pixbuf(gtkcreate_pixbuf($bg->{$wi}[2]));
} 
sub mailconf {
    my $this = shift;
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Mail configuration"), 'mailnews'),
			    0, Gtk2::Label->new(N("\nChoose the mail client you want to use and configure it\n")),
			    1, gtkadd(gtkset_shadow_type(Gtk2::Frame->new(N("Mail Parameters")), 'etched_in'),
				      gtkpack_(Gtk2::VBox->new(0, 3),
					       0, create_packtable({ homogeneous => 1, col_spacings => 10, row_spacings => 15 },
								   [ N("Mail Client:"), $this->{mailclient} = get_mailer(1), N("Server Type:"), $this->{server} = get_mailer(0) ],
								  ),
					       0, gtkpack_($this->{vbox} = Gtk2::VBox->new(0, 3),
							   0, create_packtable({ homogeneous => 1, col_spacings => 10, row_spacings => 15 },
									       [ N("Mail Address:"), $this->{mailadd} = Gtk2::Entry->new() ],
									       [ N("Incoming Server name(POP/IMAP):"), $this->{incservname} = Gtk2::Entry->new() ],
									       [ N("Outgoing server name(SMTP):"), $this->{outservname} = Gtk2::Entry->new() ],
									       [ N("Login:"), $this->{maillogin} = Gtk2::Entry->new() ],
									      ),
							  ),
					      ),
				     ),
			    1, gtkadd(gtkset_shadow_type($this->{frame} = Gtk2::Frame->new(N("News Parameters")), 'etched_in'),
				      create_packtable({ homogeneous => 1, col_spacings => 10, row_spacings => 10 },
						       [ N("News Server:"), $this->{newsserver} = Gtk2::Entry->new() ],
						      )
				     )
			   )
		  );
    $this->grayed();
    $this->{mailclient}->entry->signal_connect(changed => sub { $this->grayed() });
    
}
sub subscribe_mdkclub {
    my $this = shift;
    $this->{product} = Gtk2::RadioButton->new_with_label(undef, N("I have a Product Key and want to register"));
    $this->{member} = Gtk2::RadioButton->new_with_label_from_widget($this->{product}, N("I am already a member"));
    $this->{nothanks} = Gtk2::RadioButton->new_with_label_from_widget($this->{product}, N("No thanks"));
    my $nb_club = Gtk2::Notebook->new; $nb_club->set_show_tabs(0); $nb_club->set_show_border(0);
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Mandrake Club Account"), 'privacy'),
			    0, Gtk2::Label->new(N("Are you a Happy Mandrake Linux user who would like to directly support\nyour favorite distribution while also receiving special membership privileges?\nThen the Mandrake Linux Users Club is just for you.\nA wide selection of great benefits and services for Club members are available,including:\n * Full Access to commercial applications\n * Special download mirror list exclusively for Club members\n * Voting for software to put in Mandrake Linux \n * Special discounts for products and services at MandrakeStore\n * ...\n\n ") . N("If you provide root password,\n This wizard will add a club urpmi source for commercial applications ")),
			    1, gtkadd(Gtk2::Frame->new(N("Registration Type")),
				      gtkpack_(Gtk2::VBox->new(0,0),
					       map { my $t = $_->[0]; my $s = $_->[1];
						     0, gtksignal_connect($this->{$t}, clicked => sub { $nb_club->set_current_page($s) })  
						 } (["product", 0 ], ["member", 1], ["nothanks", 2])
					      )
				     )
			   )
		  );
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0,3),
			    0, set_darea(N("Mandrake Club Account"), 'privacy'),
			    1, $nb_club
			   )
		  );
    gtkappend_page($nb_club,
		   gtkpack_(Gtk2::VBox->new(0, 2),
			    0, gtkadd(gtkset_shadow_type($this->{gfp} = Gtk2::Frame->new(N("Product Registration")), 'etched_in'),
				      gtkpack_(Gtk2::VBox->new(0, 5),
					       0, gtkpack_(Gtk2::HBox->new(0,2),
							   0, Gtk2::Label->new(N("Registration number:")." "),
							   1, create_packtable({ homogeneous => 0, col_spacings => 0, row_spacings => 10 },
									       [ $this->display_entry() ], ),
							  ),
					       1, create_packtable({ homogeneous => 1, col_spacings => 10, row_spacings => 10 },
								   [],
								   [ N("Complete Name:"), $this->{name} = entry_sized() ],
								   [ N("Mail Contact:"), $this->{mailcontact} = entry_sized() ],
								   [ N("Login:"), $this->{newlogin} =  entry_sized() ],
								   [ N("Password:"), $this->{newpasswd} = entry_hidepass() ],
								   [ N("Confirm Password:"), $this->{confirm} = entry_hidepass() ],
								   [ N("Root Password:"), $this->{newroot} = entry_hidepass() ],
								  )
					      )
				     ))
		  );
    gtkappend_page($nb_club,
		   gtkpack_(Gtk2::VBox->new(0, 2),
			    0, gtkadd(Gtk2::Frame->new(N("MandrakeClub Registration Update")),
				      gtkpack_(Gtk2::VBox->new(0, 5),
					       1, create_packtable({ homogeneous => 1, col_spacings => 10, row_spacings => 10 },
								   [], [],
								   [ N("Login:"), $this->{login} = Gtk2::Entry->new(), "" ],
								   [ N("Password:"), $this->{passwd} = entry_hidepass(), "" ],
								   [ N("Root Password:"), $this->{root} = entry_hidepass() ],
								  )
					      ))
			   )
		  );
    gtkappend_page($nb_club,
		   gtkpack(Gtk2::Label->new(N("You can reuse this part of the wizard to register later by clicking\non Mandrake Online Services on the desktop or by connecting to \nhttp://www.mandrakeclub.com.\n Click on Forward to Finish\n")),
			  )
		  );
}
sub question {
    my $this = shift;
    my %q; my $mode = 1; my $vb; $this->{clicked} = 0;
    map {
	$q{$_->[1]} = Gtk2::RadioButton->new_with_label(undef, $_->[2]);
	$q{$_->[3]} = Gtk2::RadioButton->new_with_label_from_widget($q{$_->[1]}, $_->[4]);
	$q{$_->[5]} = Gtk2::RadioButton->new_with_label_from_widget($q{$_->[1]}, $_->[6]) if $_->[3];
	$q{$_->[7]} = Gtk2::RadioButton->new_with_label_from_widget($q{$_->[1]}, $_->[8]) if $_->[7];
	$this->{$_->[0]} = $_->[1]; 
    } (['a', 'a1', N("Yes"), 'a2', N("No")], ['b', 'b1', N("Yes"), 'b2', N("No")], ['c', 'c1', N("At Home"), 'c2', N("in a business"), 'c3', N("both")], ['d', 'd1', N("small ( < 50)"), 'd2', N("medium (50 to 500)"), 'd3', N("large (> 500)")], ['e', 'e1', N("a server"), 'e2', N("a desktop"), 'e3', N("a laptop"), 'e4', N("both")], ['f', 'f1', N("low bandwidth (56k modem)"), 'f2', N("high bandwith (ADSL, Cable ...)")], ['g', 'g1', N("Yes"), 'g2', N("No")]);
    $q{g2}->set_active(1); $this->{g} = 'g2';
    map {
	gtkpack_($q{$_->[0]} = Gtk2::HBox->new(0,3),
		 0, Gtk2::Label->new($_->[1]),
		 1, $this->{$_->[0]} = $_->[2] ? Gtk2::Combo->new() : entry_sized()
		);
    } ([ 'dwnname', N("Name") ], [ 'dwnemail', N("Email") ], [ 'dwncountry', N("Country"), '1']);
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Mandrake Survey"), 'privacy'),
			    1, privacy_text()
			   )
		  );
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Mandrake Survey"), 'privacy'),
			    1, gtkpack_(Gtk2::VBox->new(0, 5),
					0, gtksignal_connect(gtkset_active($this->{donotsend} = Gtk2::CheckButton->new(N("Do not send this questionnaire")), !$mode),							     clicked => sub { $mode = !$mode; $vb->set_sensitive($mode) }),
					1, gtkpack($vb = Gtk2::VBox->new(0,0),
						   create_scrolled_window(create_packtable({ homogeneous => 0, col_spacings => 3, row_spacings => 0 },
											   map {
											       [ $_->[0], " " ], 
											       $_->[1] && [ " ", $q{$_->[1]} ], 
											       $_->[2] && [ " ", $q{$_->[2]} ],
											       $_->[3] && [ " ", $q{$_->[3]} ],
											       $_->[4] && [ " ", $q{$_->[4]} ],
											   } ( [ N("This is your first Linux system"), 'a1', 'a2'],
											       [ N("This is your first Mandrake Linux system"), 'b1', 'b2'],
											       [ N("You are using the system"), 'c1', 'c2', 'c3' ],
											       [ N("If in a business or organisation"), 'd1', 'd2', 'd3'],
											       [ N("You will use this system for"), 'e1', 'e2', 'e3', 'e4' ],
											       [ N("Your type of internet connection is"), 'f1', 'f2' ],
											       [ N("I wish to be informed about Mandrake News"), 'g1', 'g2' ],
											  #     [ '', 'dwnname'],
											       [ '', 'dwnemail'],
											       #[ '', 'dwncountry'],
											     )
											  ))
						  ))
			   )
		  );
    foreach my $l ((['a', 'a1'], ['a','a2'],['b', 'b1'], ['b','b2'],['c', 'c1'], ['c','c2'],['c', 'c3'], ['d','d1'],['d', 'd2'], ['d','d3'],['e', 'e1'], ['e','e2'],['e', 'e3'], ['e','e4'],['f', 'f1'], ['f','f2'],['g', 'g1'], ['g','g2'])) {
	$q{$l->[1]}->signal_connect(clicked => sub { $this->{$l->[0]} = $l->[1]; $this->{clicked} = 1 } );
    }
}
sub grayed {
    my $this = shift;
    my $c = $this->{mailclient}->entry->get_text() ? 1 : 0;
    foreach (qw(vbox server frame)) {
	$this->{$_}->set_sensitive($c);
    }
}
sub privacy_text {
    my $w;
    $w = create_scrolled_window(gtktext_insert(Gtk2::TextView->new, 
N(" You are just starting our Free Mandrake Linux Download Edition for the first time. 

There are now over three million Mandrake Linux users all over the world!

Please take a few seconds to fill a short questionnaire. The data from this 
questionnaire will be used only for aggregate market studies.
The text below is the privacy policy of MandrakeSoft about your personal data.") .
"\n" . 
N("What personal data do we collect ?

Various information is collected in different areas of the website;
what follows is an overview of the data we keep:

Firstly, we record your email address, name and postal address.
Secondly we give you a unique customer ID. This ID will be used to 
add additional information related to your Mandrake account such as:
    - Your subscription to mailling lists.
    - When registering a purchased product, we ask for personal
information as well as system/hardware details so that we may deliver
the best support services customized to your needs.
    - On our donation page and on our online store (MandrakeStore), we
record data for billing purpose (we do not store any credit card data).


What do we do with this information?

We never share personal information with other persons or companies -
we use this data strictly for the following purposes:
    - If you have subscribed to a mailing list, we keep this email
address in our database to provide you with customized information
and/or to enable you to participate in discussions in various mailing
lists. If you send a message to such a list, other people will see
your email address but no external parties have access to our database
of subscribers. At any time you may unsubscribe to any list by using
the appropriate form.
    - If you provide information when registering a purchased product
to receive support, we keep this information private unless the
information is required by one of our partners to deliver the support
you require.
    - If you use MandrakeStore, we also use your Customer ID to track
your order and deliver your products.
    - If you provide us with marketing information, we keep it for 
internal use only in order to improve our products so that they can 
better fit your needs whether you have purchased a product or not.


How to change / correct your personal data?

French law gives individuals the right to access, correct, modify or 
remove their own personal data that we have on record. We offer this 
as a worldwide privilege. You may execute this right at any time by 
logging to your account with your customer ID and editing your
personnal data. You can log on to this page: http://www.mandrakeonline.net")
					      )
			       );
    $w    
}
sub set_darea {
    my ($label, $pix) = @_;
    my $darea = gtkset_size_request(Gtk2::DrawingArea->new, -1, 100);
    $darea->modify_font(Gtk2::Pango::FontDescription->from_string(N("Sans Italic 17")));
    my $layout = $darea->create_pango_layout($label);
    my $pixbuf_banner = gtkcreate_pixbuf($pix);
    $darea->signal_connect(expose_event => sub {
			       fill_tiled($darea,$pixbuf_banner);
			       $darea->window->draw_layout($darea->style->white_gc, (450-($layout->get_pixel_size)[0])/2, 35, $layout);
			       0;
			   });
    $darea;
}
sub get_wm_array {
    my @wm = split(' ', `/usr/sbin/chksession -l`);
    # this is for testing on touba (prod box)
    #    unshift(@wm,'KDE');unshift(@wm,'GNOME'); unshift(@wm, 'WindowMaker');
    #    my $i = 0;
    #   foreach (@wm) { $_ eq "default" and delete $wm[$i]; $i++; last };
    return @wm;
}

sub startwm {
    my $this = shift;
    print "TOTO is ", $this->{wmdesktop}, "\n";
    my $wm = $this->{wmdesktop}->entry->get_text(); my $w;
    my $run_wm = {
		  nochoice => sub { 
		      my $auto = any::get_autologin();
		      $w = if_($auto->{autologin}, $auto->{desktop}) || chomp_(find { defined $_ } (cat_("$ENV{HOME}/.wmrc"), $ENV{GDMSESSION})) || 'KDE';   
		      exec_wm($w);
		  },
		  wmchoosen => sub {
		      write_config($wm);
		      exec_wm($wm);
		  }
		 };
    -d "$ENV{HOME}/Documents" or mkdir_p("$ENV{HOME}/Documents");
    if ($wm eq N("Choose Desktop")) { $run_wm->{nochoice}->() } else { $run_wm->{wmchoosen}->() }
}
sub exec_wm {
    my $w = shift;
    Gtk2->main_quit;
    exec("/etc/X11/Xsession", $w);
}
sub write_config {
    my $wm = shift;
    system("xsetroot -solid \"#21449C\"");
    output_p "$ENV{HOME}/.wmrc",
    qq($wm
);
    output_p "$ENV{HOME}/.gnome2/gdm",
		      qq( 
[session]
last=$wm
    );
    chmod 0600, "$ENV{HOME}/.gnome2/gdm";
    output_p "$ENV{HOME}/.desktop",
    qq(DESKTOP=$wm
); 
}
sub survey {
    my $this = shift;
    my ($resp, $send, $arch, $mail, $lang, $locale);
#We'll dont exec code when user didn't click on any RadioButton 
    $this->{clicked} or return;
    my $netconf = '/etc/sysconfig/network-scripts/ifup.d/survey.pl';
# Test Link
#    my $link = 'http://www.mandrakeonline.net/online_survey.php';
# Final Link
    my $link = 'http://poll.mandrakesoft.com/online_survey.php';
    my ($r) = cat_('/etc/mandrake-release') =~ /release\s(\S+)/;
    $arch = chomp_(`/bin/arch`);
    $locale = lang::read('', $>);
    $lang = $locale->{lang};
    $this->{dwnemail} and $mail = $this->{dwnemail}->get_text(); 
    map { $resp .= $this->{$_} } qw(a b c d e f g); 
# Options
#   online_survey.php?rep=a1b2c1d1e3f4&ver=9.2&arch=i586&lang=fr&email=toto.durand@mail.com
    if (!$this->{donotsend}->get_active()) {
	if($this->{is_network}) {
	    #my $links = $link . '?rep=' . $resp . '&ver=' . $r . '&arch=' . $arch . '&lang=' . $lang . ' &email='. $mail;
	    $send = $this->requestclub($link . '?rep=' . $resp . '&ver=' . $r . '&arch=' . $arch . '&lang=' . $lang . ' &email='. $mail);
	    #my $content = $send->content;
	    #$this->raiseerror("$links\n");
	    #$this->raiseerror("$content\n");
	} elsif( $< == 0) { 
	    output "$netconf", qq(#Automatically generated by drakfw
use strict;
use LWP::UserAgent;
use Net::HTTP;
use HTTP::Message;
use HTTP::Request;

my \$ua = LWP::UserAgent->new;
\$ua->agent("MdkClubAgent/$r" . \$ua->agent);
my \$request = HTTP::Request->new( GET => '$link.'?rep='. $resp .'&ver='. $r .'&arch='. $arch .'&email='. $mail');
my \$response = \$ua->request(\$request);
unlink $netconf;
);
	    chmod 755, $netconf;
	}
    }
    $this->{clicked} = 0;
}
sub set_themes {
    my $this = shift;
    my ($wm, $c);
    my $action_themes = {
			 KDE => sub { my %themes_kde = (
							N("Default KDE")  => [ "Galaxy", "kwin_mandrake"],
							N("KDE Keramik")  => [ "Keramik", "kwin_keramik" ],
							N("KDE Light2")   => [ "Light, 2nd revision", "kwin_kstep" ],
							N("KDE Redmond")  => [ "systemalt", "kwin_redmond" ]
						       );
				      $c = $this->{kradio};
				      mkdir_p($this->{kdeconfdir});
				      WriteDefaultTheme();
				      update_gnomekderc($this->{kdeconfdir}.'/kdeglobals', General => (
							 widgetStyle => $themes_kde{$c}[0],
					 	       ));
				      update_gnomekderc($this->{kdeconfdir}.'/kwinrc', Style => (
						         ButtonsOnLeft => 'MS',
                 					 ButtonsOnRight => 'HIAX',
							 CustomButtonPositions => 'false',
							 PluginLib => $themes_kde{$c}[1],
							 ShowToolTips => 'true'					     
						       ));
				  },
			 GNOME => sub { my %themes_gnome =(
							   N("Default Mandrake") => [ "Galaxy", "Galaxy", "gnome" ],
							   N("Ocean Dream") => [ "Sandwish", "LighthouseBlue", "Sandy" ],
							   N("Default Gnome") => [ "Simple", "Simple", "gnome" ],
							   N("Smokey Blue") => [ "Smokey", "Smokey-Blue", "Smokey-Blue" ],
							  );
					$c = $this->{gradio};
					system("gconftool-2 --type=string --set /apps/metacity/general/theme $themes_gnome{$c}[0] &");
					system("gconftool-2 --type=string --set /desktop/gnome/interface/gtk_theme $themes_gnome{$c}[1] &");
					system("gconftool-2 --type=string --set /desktop/gnome/interface/icon_theme $themes_gnome{$c}[2] &");
				    },
			 OTHER => sub { WriteDefaultTheme() }
 			};
    $wm = $this->{wmdesktop}->entry->get_text();
    if (member($wm,('KDE','GNOME'))) { eval { $action_themes->{$wm}->() } } else { $action_themes->{OTHER}->() };
    $this->{nb}->next_page();
}
sub WriteDefaultTheme {
    output "$ENV{HOME}/.gtkrc", qq (# -- THEME AUTO-WRITTEN DO NOT EDIT 
include "/usr/share/themes/Galaxy/gtk/gtkrc"

# -- THEME AUTO-WRITTEN DO NOT EDIT
);
    output "$ENV{HOME}/.gtkrc-2.0", qq (# -- THEME AUTO-WRITTEN DO NOT EDIT 
include "/usr/share/themes/Galaxy/gtk-2.0/gtkrc"

# -- THEME AUTO-WRITTEN DO NOT EDIT 
);
  
}
sub mdkclub_checkuser {
    my $this = shift;
    $this->{productkey} = '';
    map { $this->{productkey} .= $this->{$_}->get_text() } qw (ent1 ent2 ent3 ent4 ent5); 
    my $link = 'http://www.mandrakeclub.com/add_user.php';
    my $subsclub = {
		    0 => sub { if ($this->{newroot}->get_text()) { $this->AddUrpmiSource(1) }; $this->display_last_page() },
		    1 => sub { $this->raiseerror(N("Wrong Product Code \"%s\". Please provide a Correct Registration number or Skip the wizard \n", $this->{productkey})) },
		    2 => sub { $this->raiseerror(N("Nickname * %s * already in use or invalid\nPlease choose another one\n", $this->{newlogin}->get_text()))},
		    3 => sub { $this->raiseerror(N("Email already in use or invalid\nCould you provide another one\n")) },
		    4 => sub { $this->raiseerror(N("Password is invalid\n Please Change it")) },
		    5 => sub { $this->raiseerror(N("Database error at server side\n Please connect later with drakclub or drakonline wizard")) },
		    6 => sub { if ($this->{root}->get_text()) { $this->AddUrpmiSource(0) }; $this->display_last_page() },
		    7 => sub { $this->raiseerror(N("You should register to club first. Click back \nand select first choice"))}
		   };
    my $callback_club = {
	  
			 product => sub { 
			     if ($this->{newpasswd}->get_text() ne $this->{confirm}->get_text()) { 
				 $this->raiseerror(N("The passwords do not match\n Please try again\n"))
			     } elsif (check_valid_email($this->{mailcontact}) != 1) { 
				 $this->raiseerror(N("Not a valid mail address!\n")) 
			     } else {
				 $this->{response} = $this->requestclub($link.'?Pcode='.$this->{productkey}.'&CUSTnick='.$this->{newlogin}->get_text().'&CUSTemail='.$this->{mailcontact}->get_text().'&CUSTpass='.$this->{newpasswd}->get_text());
				 if ($this->{response}->is_success) {
				     my $content = $this->{response}->content;
				     if ($content =~ m/(\d+)/) { my $code = sprintf("%d",$1); eval { $subsclub->{$code}->() } }
				 } else { $this->raiseerror(N("Problem connecting to server \n")) }
			     }
			 },
			 member => sub { 
			     if (!$this->{login}->get_text()) { $this->raiseerror(N("Login must be provided")) } else {
				 $this->{response} = $this->requestclub($link.'?CUSTnick='.$this->{login}->get_text().'&CUSTpass='.$this->{passwd}->get_text());
				 if ($this->{response}->is_success) {
				     my $content = $this->{response}->content;
				     if ($content =~ m/(\d+)/) { my $code = sprintf("%d",$1); print "##\n$code ##\n" ; eval { $subsclub->{$code}->() } }  
				 } else { $this->raiseerror(N("Problem connecting to server \n")) }
			     }
			 },
			 nothanks => sub { $this->display_last_page() },
			}; 
    map {
	$this->{$_}->get_active() and $callback_club->{$_}->();
    } keys %{ $callback_club };
}
sub AddUrpmiSource {
    my $this = shift;
    my $p = shift; #notebook page 
    my ($login, $password, $rootpassword, $commsu, $ret);
    if ($p) { 
	$login = $this->{newlogin}->get_text(); $password = $this->{newpasswd}->get_text(); $rootpassword = $this->{newroot}->get_text() 
    } else { $login = $this->{login}->get_text; $password = $this->{passwd}->get_text(); $rootpassword = $this->{root}->get_text() };
    my ($r) = cat_('/etc/mandrake-release') =~ /release\s(\S+)/;
    my $w = wait_msg(N("Please wait, contacting MandrakeClub to initialize updates packages."));
    map {
	my $stringified = "/usr/sbin/urpmi.addmedia --wget club." . $_ . "_i586_" . $r . " http://" . $login . ":" . $password ."\@www.mandrakeclub.com/downloads2/" . $_ . "/" . $r . " with ./hdlist.cz";
	$commsu = Expect->spawn("su -m -l -c \"$stringified\" root");
	unless ($commsu->expect(10,"Password: ")) { #Wait 10 seconds and give up
	    $this->raiserror(N("Never got password prompt for su\n Error message is %s", $commsu->exp_error()));
	}
	print $commsu "$rootpassword\r";
	$commsu->interact();
	#	$ret = system($stringified);
    }('comm'); #removed urpmi test source 
    remove_wait_msg($w);
    $ret and $this->raiseerror(N("Cannot add Club Source. Please check your network connection\n or contact MandrakeClub administrator"));
}
sub wait_msg {
    my ($msg, %options) = @_;
    my $mainw = ugtk2->new('club', grab => 1, if_(exists $options{transient}, transient => $options{transient}));
    my $label = ref($msg) =~ /^Gtk/ ? $msg : Gtk2::Label->new($msg);
    gtkadd($mainw->{window}, gtkpack(gtkadd(create_vbox(), $label, if_(exists $options{widgets}, @{$options{widgets}}))));
    $label->signal_connect(expose_event => sub { $mainw->{displayed} = 1; 0 });
    $mainw->sync until $mainw->{displayed};
    gtkset_mousecursor_wait($mainw->{rwindow}->window);
    $mainw->flush;
    $mainw;
}
sub remove_wait_msg { $_[0]->destroy }
sub requestclub {
    my $this = shift;
    my $ua = LWP::UserAgent->new;
    $ua->agent("MdkClubAgent/%s" . $ua->agent, $this->{version});
    my $request = HTTP::Request->new( GET => @_);
    my $response = $ua->request($request); 
    $response;
}
sub check_valid_email {
    my $email = shift;
    my $st = $email->get_text() =~/^[a-z][a-z0-9_\-]+(\.[a-z][a-z0-9_]+)?@([a-z][a-z0-9_\-]+\.){1,3}(\w{2,4})(\.[a-z]{2})?$/ix ? 1 : 0;
    return $st
}
sub get2final {
    my $this = shift;
    $this->{Button_Prev}->hide; $this->{Button_SkipWiz}->hide;
    $this->{Button_Next}->set_label(N("Finish"));
}
sub display_last_page {
    my $this = shift;
    $this->get2final();
    $this->{nb}->next_page;
}
sub raiseerror {
    my $this = shift;
    my $w = ugtk2->new(N("Error"), grab => 1, center => 1, transient => $this->{mw}->{rwindow});
    $w->{rwindow}->set_position('center');
    gtkadd($w->{window},
	   gtkpack_(Gtk2::VBox->new,
		    1, Gtk2::Label->new($_[0]),
		    0, Gtk2::HSeparator->new,
		    0, gtksignal_connect(Gtk2::Button->new(N("Ok")), clicked => sub { Gtk2->main_quit; })
		   ),
	  );
    $w->main;
}
sub set_mail {
    my $this = shift;
    my ($mc, $serv) = map { $this->{$_}->entry->get_text() } qw(mailclient server);
    my ($ma, $isn, $osn, $ml, $ns) = map { $this->{$_}->get_text() } qw(mailadd incservname outservname maillogin newsserver);
    my $port;
    my $bindport = { POP => 110, IMAP => 143, SPOP => 995, SIMAP => 993 }; 
    $port = member($serv, keys %$bindport) ? $bindport->{$serv} : '';  
    my $mail_cb = {
		   Kmail => sub { $this->write_kmailconf($serv, $ma, $isn, $osn, $ml, $port, $ns) },
		   Evolution => sub {$this->write_evoconf($serv, $ma, $isn, $osn, $ml, $ns) },
		   Mozilla => sub { $this->write_mozillaconf($serv, $ma, $isn, $osn, $ml, $port, $ns) }
		  };
    member($mc, 'Kmail', 'Evolution') and eval { $mail_cb->{$mc}->() };
    if ($mc eq 'Mozilla') { !-d $this->{mozillaconfdir} and $mail_cb->{$mc}->() };
    $this->{nb}->next_page();
    $ma && $this->{dwnemail} and $this->{dwnemail}->set_text($ma);
}
sub write_kmailconf {
    my $this = shift;
    my ($serv, $ma, $isn, $osn, $ml, $port, $ns) = @_;
    my $n = read_kmailconf();
    print " Number of accounts = $n \n";
    $serv = lc($serv);
    mkdir_p($this->{kdeconfdir});
    update_gnomekderc($this->{kdeconfdir}.'/kmailrc', 'Account ' . $n => (
			      Folder => "inbox",
			      Type => $serv,
			      host => $isn,
			      login => $ml,
			      passwd => "",
			      port => $port
		     ));
    update_gnomekderc($this->{kdeconfdir}.'/kmailrc', General => ( accounts => "$n"));
    update_gnomekderc($this->{kdeconfdir}.'/kmailrc', 'Identity ' . $n => (
			     'Email Address' => $ma,
 			     'Name' => $ml,
 			     'Organization' => "Gnu-Linux" 
     		      ));
    update_gnomekderc($this->{kdeconfdir}.'/kmailrc', 'sending mail' => (
 			     'Immediate' => "true",
			     'Mailer' => "/usr/sbin/sendmail",
			     'Method' => "smtp",
			     'Smtp Host' => $osn,
			     'Smtp Port' => "25"
		      ));
    if ($ns && -e "/usr/bin/knode") {
	mkdir_p("$ENV{HOME}/.kde/share/apps/knode/nntp.1");
	setVarsInSh("$ENV{HOME}/.kde/share/apps/knode/nntp.1/info", { Email => $ma , Name => $ml, Org => "Gnu-Linux", id => "1", name => N("My news"), needsLogon => "true", pass => "", port => "119", server => $ns, user => $ml });
	my ($vn) = (`knode -v`) =~ m/KNode: (.*)/ ; 
	update_gnomekderc($this->{kdeconfdir}.'/knoderc', GENERAL => ( Version => $vn ));
	update_gnomekderc($this->{kdeconfdir}.'/knoderc', IDENTITY => (
			       Email => $ma,
			       Name => "Tux",
			       Org => "Gnu-Linux"
		         ));
    }
}
sub read_kmailconf {
    my %k;
    %k = getVarsFromSh("$ENV{HOME}/.kde/share/config/kmailrc");
    return $k{accounts} ? ++$k{accounts} : 1;
}
sub write_evoconf {
    my $this = shift;
    my ($serv, $ma, $isn, $osn, $ml, $port, $ns) = @_;
    if (-d $this->{evoconfdir}) {
	$this->RaiseError(N("An evolution directory already exists.\nWe dont want to clobber it, please use evolution directly\n"));
    } else {
	my $evoxmlstr = '[<account name="'.$ma.'" uid="0" enabled="true"><identity><name>'.$ml.'</name><addr-spec>'.$ma.'</addr-spec><reply-to>'.$ma.'</reply-to><organization>GNU Linux</organization><signature auto="false" default="-1"/></identity><source save-passwd="false" keep-on-server="false" auto-check="false" auto-check-timeout="0"><url>'.lc($serv).'://'.$ml.'@'.$isn.'</url></source><transport save-passwd="false"><url>smtp://'.$ml.'@'.$osn.'</url></transport><drafts-folder>file://'.$this->{evoconfdir}.'/local/Drafts</drafts-folder><sent-folder>file://'.$this->{evoconfdir}.'/local/Sent</sent-folder><auto-cc always="false"><recipients></recipients></auto-cc><auto-bcc always="false"><recipients></recipients></auto-bcc><pgp encrypt-to-self="false" always-trust="false" always-sign="false" no-imip-sign="false"><key-id></key-id></pgp><smime encrypt-to-self="false" always-sign="false"/></account>]';
	mkdir_p($this->{evoconfdir});
	system("cp -af /usr/share/evolution/1.4/default_user/*  $this->{evoconfdir}");
	system("gconftool-2 --type=list --list-type=string --set /apps/evolution/mail/accounts \'$evoxmlstr\' &")
    }
}
sub write_mozillaconf {
    my $this = shift;
    my ($serv, $ma, $isn, $osn, $ml, $port, $ns) = @_;
    my ($f, $dn);
    $serv = lc($serv);
    mkdir_p($this->{mozillaconfdir}); 
    my $mail_i18n = N("My Mail"); my $news_i18n = N("My News");
    opendir(MOZ, $this->{mozillaconfdir});
    $dn = find { /\.slt$/ } readdir MOZ ;
    closedir(MOZ);
    $dn ||= randomize(); # Create a random file for mozilla-mail
    my $maildir = $this->{mozillaconfdir} . "/" . "$dn";
    map { 
	mkdir_p($maildir . "/" . "Mail" . "/". $_) ;
	chdir($maildir . "/Mail" . "/" . $_);
	foreach my $l ("Drafts", "Sent", "Templates", "Trash", "Unsent Messages") { touch $l };
	$_ eq $isn and touch "Inbox";
    } ("Local Folders", "$isn");
    my $nf = $maildir . "/News/"."newsrc-" . ($ns || "mynews");
    mkdir_p($maildir . "/" . "News"); touch $nf; chmod 755, $nf; 
    touch "$maildir/prefs.bak";
    output "$maildir/prefs.js", qq(#Mozilla User Preferences
//This is a generated file!

user_pref("mail.account.account1.identities", "id1");
user_pref("mail.account.account1.server", "server1");
user_pref("mail.account.account2.server", "server2");
user_pref("mail.account.account3.identities", "id2");
user_pref("mail.account.account3.server", "server3");
user_pref("mail.accountmanager.accounts", "account1,account2,account3");
user_pref("mail.accountmanager.defaultaccount", "account1");
user_pref("mail.accountmanager.localfoldersserver", "server2");
user_pref("mail.identity.id1.draft_folder", "mailbox://$ml\@$isn/Drafts");
user_pref("mail.identity.id1.drafts_folder_picker_mode", "0");
user_pref("mail.identity.id1.fcc_folder", "mailbox://$ml\@$isn/Sent");
user_pref("mail.identity.id1.fcc_folder_picker_mode", "0");
user_pref("mail.identity.id1.fullName", "$ml");
user_pref("mail.identity.id1.smtpServer", "smtp1");
user_pref("mail.identity.id1.stationery_folder", "mailbox://$ml\@$isn/Templates");
user_pref("mail.identity.id1.tmpl_folder_picker_mode", "0");
user_pref("mail.identity.id1.useremail", "$ma");
user_pref("mail.identity.id1.valid", true);
user_pref("mail.identity.id2.compose_html", false);
user_pref("mail.identity.id2.drafts_folder_picker_mode", "0");
user_pref("mail.identity.id2.fcc_folder_picker_mode", "0");
user_pref("mail.identity.id2.fullName", "$ml");
user_pref("mail.identity.id2.smtpServer", "smtp1");
user_pref("mail.identity.id2.tmpl_folder_picker_mode", "0");
user_pref("mail.identity.id2.useremail", "$ma");
user_pref("mail.identity.id2.valid", true);
user_pref("mail.newsrc_root", "$maildir/News")
user_pref("mail.root.none", "$maildir/Mail");
user_pref("mail.root.pop3", "$maildir/Mail");
user_pref("mail.server.server1.directory", "$maildir/Mail/$isn");
user_pref("mail.server.server1.download_on_biff", true);
user_pref("mail.server.server1.hostname", "$isn");
user_pref("mail.server.server1.login_at_startup", true);
user_pref("mail.server.server1.name", "$mail_i18n");
user_pref("mail.server.server1.type", "$serv");
user_pref("mail.server.server1.userName", "$ml");
user_pref("mail.server.server2.directory", "$maildir/Mail/Local Folders");
user_pref("mail.server.server2.hostname", "Local Folders");
user_pref("mail.server.server2.name", "Local Folders");
user_pref("mail.server.server2.type", "none");
user_pref("mail.server.server2.userName", "nobody");
user_pref("mail.server.server3.directory", "$maildir/News/$ns");
user_pref("mail.server.server3.hostname", "$ns");
user_pref("mail.server.server3.name", "$news_i18n");
user_pref("mail.server.server3.newsrc.file", "$maildir/News/newsrc-$ns");
user_pref("mail.server.server3.type", "nntp");
user_pref("mail.smtp.defaultserver", "smtp1");
user_pref("mail.smtpserver.smtp1.hostname", "$osn");
user_pref("mail.smtpserver.smtp1.username", "$ml");
user_pref("mail.smtpservers", "smtp1");
user_pref("mail.startup.enabledMailCheckOnce", true);
user_pref("mail.ui.folderpane.version", 3);
user_pref("mailnews.ui.addressbook_results.version", 2);
user_pref("mailnews.ui.threadpane.version", 2);
user_pref("network.cookie.cookieBehavior", 0);
user_pref("prefs.converted-to-utf8", true);

) 
}
sub randomize {
    my @dir = ((1..9), ('a'..'z'));
    my $i; my $dr;
    for ($i = $#dir, --$i) {
	my $j = int(rand ($i+1));
	next if $i == $j;
	@dir[$i,$j] = @dir[$j,$i]
    }
    $dr = join('', reverse(splice(@dir, 7, 8))) . ".slt";
    $dr;
}
sub on_next_clicked {
    my ($this, $stage) = @_;
    $this->{Button_Prev}->set_sensitive(1);
    my $page = $this->{nb}->get_current_page();
    $page == 8 and $this->get2final();
    !$this->{is_download} && $page == 6 and $this->get2final(); 
    if (exists($stage->{$page})) { $stage->{$page}->() } else { $this->{nb}->next_page() };
}   
sub on_prev_clicked {
    my ($this, $stage) = @_;
    my $page = $this->{nb}->get_current_page();
    $page == 1 and $this->{Button_Prev}->set_sensitive(0);
    $this->{Button_Next}->get_label() eq N("Finish") and $this->{Button_Next}->set_label(N("  Next  > "));
    $this->{nb}->prev_page();
}

1;
